.include "man/entity.h.s"
.include "man/game.h.s"
.include "assets/assets.h.s"
.include "man/behaviors/shooting.h.s"
.include "sys/collision.h.s"
.include "sys/ia.h.s"
.include "sys/animation.h.s"
.include "utils.h.s"
.include "cfg.h.s"


;; PLAYER
SetFieldB ENT_TYPE_FLAG                 , ENTITY_TYPE_FLAG_PLAYER
SetFieldB ENT_TYPE_ID                   , ENTITY_TYPE_ID_PLAYER
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_TILE_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_INPUT
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_ENERGY
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 10<<WORLD_SCALE_Y_DISP
SetFieldW ENT_X_WORLD              , 10<<WORLD_SCALE_X_DISP
SetFieldB ENT_Y                    , 10
SetFieldB ENT_X                    , 10
SetFieldB ENT_VEL_Y                , 2
SetFieldB ENT_VEL_X                , 1
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , PLAYER_ACCELERATION_Y
SetFieldB ENT_FRICTION_X_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_X           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y_DEFAULT   , 1
SetFieldB ENT_FRICTION_Y           , 1
SetFieldB ENT_WIDTH                , SPRITE_PLAYER_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_PLAYER_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_player_00
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_NULL
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 8
SetFieldB ENT_HEALTH               , 8
SetFieldB ENT_ATTACK               , 1
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_BOSS_SHOT|ENTITY_TYPE_FLAG_NEXT_MAP|ENTITY_TYPE_FLAG_LOLLIPOP
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_standing_right
SetFieldW ENT_LAST_SPRITE          , #_sprite_player_00
SetFieldW ENT_ANIMATION_ARRAY      , #_player_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 40
SetFieldB ENT_DEATH_COUNTER        , 80
SetFieldW ENT_DEATH_ANIMATION      , #_player_death_animation
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity player

;; BOLD MINION
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_MINION
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_MINION
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_AI
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_TILE_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 10<<WORLD_SCALE_Y_DISP
SetFieldW ENT_X_WORLD              , 10<<WORLD_SCALE_X_DISP
SetFieldB ENT_Y                    , 10
SetFieldB ENT_X                    , 10
SetFieldB ENT_VEL_Y                , 2
SetFieldB ENT_VEL_X                , 1
SetFieldB ENT_ACCELERATION_X       , 1
SetFieldB ENT_ACCELERATION_Y       , PLAYER_ACCELERATION_Y
SetFieldB ENT_FRICTION_X_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_X           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y_DEFAULT   , 1
SetFieldB ENT_FRICTION_Y           , 1
SetFieldB ENT_WIDTH                , SPRITE_MINIONS_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_MINIONS_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_minions_00
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_wandering_minion_0
SetFieldB ENT_MAX_HEALTH           , HEALTH_BOLD_MINION
SetFieldB ENT_HEALTH               , HEALTH_BOLD_MINION
SetFieldB ENT_ATTACK               , 1
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER|ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldW ENT_CURRENT_ANIMATION    , #_bold_standing_right
SetFieldW ENT_LAST_SPRITE          , #_sprite_minions_00
SetFieldW ENT_ANIMATION_ARRAY      , #_bold_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 10
SetFieldB ENT_DEATH_COUNTER        , 62
SetFieldW ENT_DEATH_ANIMATION      , #_bold_death_animation
SetFieldB ENT_FACING_DIR           , 1
SetFieldW ENT_POINTS               , POINTS_BOLD_MINION
DefineEntity bold_minion


;; BOY MINION
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_MINION
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_MINION
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_AI
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_TILE_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 10<<WORLD_SCALE_Y_DISP
SetFieldW ENT_X_WORLD              , 10<<WORLD_SCALE_X_DISP
SetFieldB ENT_Y                    , 10
SetFieldB ENT_X                    , 10
SetFieldB ENT_VEL_Y                , 2
SetFieldB ENT_VEL_X                , 1
SetFieldB ENT_ACCELERATION_X       , 1
SetFieldB ENT_ACCELERATION_Y       , PLAYER_ACCELERATION_Y
SetFieldB ENT_FRICTION_X_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_X           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y_DEFAULT   , 1
SetFieldB ENT_FRICTION_Y           , 1
SetFieldB ENT_WIDTH                , SPRITE_MINIONS_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_MINIONS_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_minions_10
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_shooting_minion_0
SetFieldB ENT_MAX_HEALTH           , 2
SetFieldB ENT_HEALTH               , HEALTH_BOY_MINION
SetFieldB ENT_ATTACK               , HEALTH_BOY_MINION
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER|ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldW ENT_CURRENT_ANIMATION    , #_boy_standing_right
SetFieldW ENT_LAST_SPRITE          , #_sprite_minions_10
SetFieldW ENT_ANIMATION_ARRAY      , #_boy_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 10
SetFieldB ENT_DEATH_COUNTER        , 62
SetFieldW ENT_DEATH_ANIMATION      , #_boy_death_animation
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_BOY_MINION
DefineEntity boy_minion


;; GIRL MINION
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_MINION
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_MINION
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_AI
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_TILE_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 10<<WORLD_SCALE_Y_DISP
SetFieldW ENT_X_WORLD              , 10<<WORLD_SCALE_X_DISP
SetFieldB ENT_Y                    , 10
SetFieldB ENT_X                    , 10
SetFieldB ENT_VEL_Y                , 2
SetFieldB ENT_VEL_X                , 1
SetFieldB ENT_ACCELERATION_X       , 1
SetFieldB ENT_ACCELERATION_Y       , PLAYER_ACCELERATION_Y
SetFieldB ENT_FRICTION_X_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_X           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y_DEFAULT   , 1
SetFieldB ENT_FRICTION_Y           , 1
SetFieldB ENT_WIDTH                , SPRITE_MINIONS_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_MINIONS_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_minions_20
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_crazy_minion_0
SetFieldB ENT_MAX_HEALTH           , HEALTH_GIRL_MINION
SetFieldB ENT_HEALTH               , HEALTH_GIRL_MINION
SetFieldB ENT_ATTACK               , 1
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER|ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldW ENT_CURRENT_ANIMATION    , #_girl_standing_right
SetFieldW ENT_LAST_SPRITE          , #_sprite_minions_20
SetFieldW ENT_ANIMATION_ARRAY      , #_girl_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 10
SetFieldB ENT_DEATH_COUNTER        , 62
SetFieldW ENT_DEATH_ANIMATION      , #_girl_death_animation
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_GIRL_MINION
DefineEntity girl_minion


;; RAT MINION
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_MINION
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_MINION
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_AI
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_TILE_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 10<<WORLD_SCALE_Y_DISP
SetFieldW ENT_X_WORLD              , 10<<WORLD_SCALE_X_DISP
SetFieldB ENT_Y                    , 10
SetFieldB ENT_X                    , 10
SetFieldB ENT_VEL_Y                , 2
SetFieldB ENT_VEL_X                , 1
SetFieldB ENT_ACCELERATION_X       , 1
SetFieldB ENT_ACCELERATION_Y       , PLAYER_ACCELERATION_Y
SetFieldB ENT_FRICTION_X_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_X           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y_DEFAULT   , 1
SetFieldB ENT_FRICTION_Y           , 1
SetFieldB ENT_WIDTH                , SPRITE_RAT_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_RAT_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_rat_0
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_wandering_minion_0
SetFieldB ENT_MAX_HEALTH           , HEALTH_RAT
SetFieldB ENT_HEALTH               , HEALTH_RAT
SetFieldB ENT_ATTACK               , 1
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER|ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldW ENT_CURRENT_ANIMATION    , #_rat_standing_right
SetFieldW ENT_LAST_SPRITE          , #_sprite_rat_0
SetFieldW ENT_ANIMATION_ARRAY      , #_rat_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 10
SetFieldB ENT_DEATH_COUNTER        , 62
SetFieldW ENT_DEATH_ANIMATION      , #_rat_death_animation
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_RAT
DefineEntity rat_minion



;;BIRD MINION
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_MINION
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_BIRD
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_AI
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 100
SetFieldB ENT_X                    , 50
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , BIRD_FRICTION
SetFieldB ENT_FRICTION_X           , BIRD_FRICTION
SetFieldB ENT_FRICTION_Y_DEFAULT   , BIRD_FRICTION
SetFieldB ENT_FRICTION_Y           , BIRD_FRICTION
SetFieldB ENT_WIDTH                , SPRITE_BIRD_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_BIRD_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_bird_0
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_bird_s0
SetFieldB ENT_MAX_HEALTH           , HEALTH_BIRD
SetFieldB ENT_HEALTH               , HEALTH_BIRD
SetFieldB ENT_ATTACK               , 1
_AUX_INFLICTS = 0
_AUX_INFLICTS = _AUX_INFLICTS | ENTITY_TYPE_FLAG_PLAYER
_AUX_INFLICTS = _AUX_INFLICTS | ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldB ENT_INFLICTS_DAMAGE_ON   , _AUX_INFLICTS
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_bird_standing_right
SetFieldW ENT_LAST_SPRITE          , #_sprite_bird_0
SetFieldW ENT_ANIMATION_ARRAY      , #_bird_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 5
SetFieldW ENT_DEATH_ANIMATION      , #_animation_bird_death
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_BIRD
DefineEntity bird_minion


;;BOSS 1
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_BOSS
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_BOSS1
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
_COMPONENTS_AUX = _COMPONENTS_AUX | COMPONENT_L_AI
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_TILE_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_ENERGY
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 4
SetFieldB ENT_FRICTION_X_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_X           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , SPRITE_BOSS1_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_BOSS1_HEIGHT
SetFieldW ENT_SPRITE               , #_boss1_00
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_boss1_s0
SetFieldB ENT_MAX_HEALTH           , HEALTH_BOSS1
SetFieldB ENT_HEALTH               , HEALTH_BOSS1
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER|ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_boss1_standing_right
SetFieldW ENT_LAST_SPRITE          , #_boss1_00
SetFieldW ENT_ANIMATION_ARRAY      , #_boss1_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 10
SetFieldB ENT_DEATH_COUNTER        , BOSS_DEATH_COUNTER
SetFieldW ENT_DEATH_ANIMATION      , #_animation_boss1_death
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_BOSS1
DefineEntity boss1

;;BOSS 2
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_BOSS
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_BOSS2
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
_COMPONENTS_AUX = _COMPONENTS_AUX | COMPONENT_L_AI
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_TILE_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_ENERGY
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 10<<WORLD_SCALE_Y_DISP
SetFieldW ENT_X_WORLD              , 10<<WORLD_SCALE_X_DISP
SetFieldB ENT_Y                    , 10
SetFieldB ENT_X                    , 10
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 4
SetFieldB ENT_FRICTION_X_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_X           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , SPRITE_BOSS2_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_BOSS2_HEIGHT
SetFieldW ENT_SPRITE               , #_boss2_0
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_boss2_s0
SetFieldB ENT_MAX_HEALTH           , HEALTH_BOSS2
SetFieldB ENT_HEALTH               , HEALTH_BOSS2
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER|ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_boss2_standing_right
SetFieldW ENT_LAST_SPRITE          , #_boss2_0
SetFieldW ENT_ANIMATION_ARRAY      , #_boss2_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 10
SetFieldB ENT_DEATH_COUNTER        , BOSS_DEATH_COUNTER
SetFieldW ENT_DEATH_ANIMATION      , #_animation_boss2_death
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_BOSS2
DefineEntity boss2

;;BOSS 3
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_BOSS
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_BOSS4
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
_COMPONENTS_AUX = _COMPONENTS_AUX | COMPONENT_L_AI
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_TILE_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_ENERGY
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 10<<WORLD_SCALE_Y_DISP
SetFieldW ENT_X_WORLD              , 10<<WORLD_SCALE_X_DISP
SetFieldB ENT_Y                    , 10
SetFieldB ENT_X                    , 10
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 4
SetFieldB ENT_FRICTION_X_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_X           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , SPRITE_BOSS3_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_BOSS3_HEIGHT
SetFieldW ENT_SPRITE               , #_boss3_0
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_boss3_s0
SetFieldB ENT_MAX_HEALTH           , HEALTH_BOSS3
SetFieldB ENT_HEALTH               , HEALTH_BOSS3
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER|ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_boss3_doing_nothing
SetFieldW ENT_LAST_SPRITE          , #_boss3_0
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 10
SetFieldB ENT_DEATH_COUNTER        , BOSS_DEATH_COUNTER
SetFieldW ENT_DEATH_ANIMATION      , #_animation_boss3_death
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_BOSS3
DefineEntity boss3

;;BOSS 4
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_BOSS
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_BOSS4
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
_COMPONENTS_AUX = _COMPONENTS_AUX | COMPONENT_L_AI
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_TILE_COLLISION
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_ENERGY
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 10<<WORLD_SCALE_Y_DISP
SetFieldW ENT_X_WORLD              , 10<<WORLD_SCALE_X_DISP
SetFieldB ENT_Y                    , 10
SetFieldB ENT_X                    , 10
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 4
SetFieldB ENT_FRICTION_X_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_X           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , SPRITE_BOSS4_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_BOSS4_HEIGHT
SetFieldW ENT_SPRITE               , #_boss4_00
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_boss4_s0
SetFieldB ENT_MAX_HEALTH           , HEALTH_BOSS4
SetFieldB ENT_HEALTH               , HEALTH_BOSS4
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER|ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_boss4_standing_right
SetFieldW ENT_LAST_SPRITE          , #_boss4_00
SetFieldW ENT_ANIMATION_ARRAY      , #_boss4_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 10
SetFieldB ENT_DEATH_COUNTER        , BOSS_DEATH_COUNTER
SetFieldW ENT_DEATH_ANIMATION      , #_animation_boss4_death
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_BOSS4
DefineEntity boss4

;;PLAYER SHOT
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_PLAYER_SHOT
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , -20
SetFieldB ENT_VEL_X                , 80
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 4
SetFieldB ENT_FRICTION_X_DEFAULT   , 1
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , SPRITE_PLAYER_SHOT_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_PLAYER_SHOT_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_player_shot_0
_AUX_COLLIDES = 0
_AUX_COLLIDES = _AUX_COLLIDES | ENTITY_TYPE_FLAG_BOSS
_AUX_COLLIDES = _AUX_COLLIDES | ENTITY_TYPE_FLAG_MINION
SetFieldB ENT_COLLIDES_WITH        , _AUX_COLLIDES
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , 1
SetFieldB ENT_INFLICTS_DAMAGE_ON   , _AUX_COLLIDES
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_player_shoot
SetFieldW ENT_LAST_SPRITE          , #_sprite_player_shot_0
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #_player_death_animation
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity playerShot

;;BOSS SHOTGUN SHOT
SetFieldB ENT_TYPE_FLAG             , ENTITY_TYPE_FLAG_BOSS_SHOT
SetFieldB ENT_TYPE_ID               , ENTITY_TYPE_ID_BOSS_SHOT
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
;;_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 30
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , SPRITE_BOSS_SHOT_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_BOSS_SHOT_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_boss_shot
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_CURRENT_ANIMATION    , #_dont_animate
SetFieldW ENT_LAST_SPRITE          , #_sprite_boss_shot
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #_player_death_animation
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity bossShotgunShot



;;SPIKES
SetFieldB ENT_TYPE_FLAG             , ENTITY_TYPE_FLAG_SPIKES
SetFieldB ENT_TYPE_ID               , ENTITY_TYPE_ID_SPIKES
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
;;_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , SPIKES_WIDTH
SetFieldB ENT_HEIGHT               , SPIKES_HEIGHT
SetFieldW ENT_SPRITE               , #_spikes
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER|ENTITY_TYPE_FLAG_MINION
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 127
SetFieldB ENT_HEALTH               , 127
SetFieldB ENT_ATTACK               , 3
_DAMAGE_ON = 0
_DAMAGE_ON = _DAMAGE_ON | ENTITY_TYPE_FLAG_PLAYER
_DAMAGE_ON = _DAMAGE_ON | ENTITY_TYPE_FLAG_MINION
SetFieldB ENT_INFLICTS_DAMAGE_ON   , _DAMAGE_ON
SetFieldW ENT_CURRENT_ANIMATION    , #_dont_animate
SetFieldW ENT_LAST_SPRITE          , #_spikes
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #0x0000
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity spikes


;;Lollipop
SetFieldB ENT_TYPE_FLAG             , ENTITY_TYPE_FLAG_LOLLIPOP
SetFieldB ENT_TYPE_ID               , ENTITY_TYPE_ID_LOLLIPOP
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
;;_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , LOLLIPOP_WIDTH
SetFieldB ENT_HEIGHT               , LOLLIPOP_HEIGHT
SetFieldW ENT_SPRITE               , #_lollipop
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , LOLLIPOP_HEALTH_INCREASED
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_CURRENT_ANIMATION    , #_dont_animate
SetFieldW ENT_LAST_SPRITE          , #_lollipop
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #_player_death_animation
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_LOLLIPOP
DefineEntity lollipop

;;BOSS SHOT
SetFieldB ENT_TYPE_FLAG             , ENTITY_TYPE_FLAG_BOSS_SHOT
SetFieldB ENT_TYPE_ID               , ENTITY_TYPE_ID_BOSS_SHOT
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
;;_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 30
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , SPRITE_BOSS_SHOT_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_BOSS_SHOT_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_boss_shot
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_CURRENT_ANIMATION    , #_dont_animate
SetFieldW ENT_LAST_SPRITE          , #_sprite_boss_shot
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #_player_death_animation
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity bossShot

;;STATIC BIRD SHOT
SetFieldB ENT_TYPE_FLAG             , ENTITY_TYPE_FLAG_BOSS_SHOT
SetFieldB ENT_TYPE_ID               , ENTITY_TYPE_ID_BOSS_SHOT
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
;;_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , SPRITE_PLAYER_SHOT_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_PLAYER_SHOT_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_player_shot_0
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , 1
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_player_shoot
SetFieldW ENT_LAST_SPRITE          , #_sprite_player_shot_0
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #_player_death_animation
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity staticBirdShot

;;BIRD AS BULLET SHOT
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_MINION
SetFieldB ENT_TYPE_ID              , ENTITY_TYPE_ID_MINION
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_PHYSICS
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_AI
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
_COMPONENTS_AUX_H = 0
_COMPONENTS_AUX_H = _COMPONENTS_AUX_H |	COMPONENT_H_BOUNDARY_COLLISION
SetFieldB ENT_COMPONENTS_H         , _COMPONENTS_AUX_H
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 100
SetFieldB ENT_X                    , 50
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , #3
SetFieldB ENT_FRICTION_X           , #3
SetFieldB ENT_FRICTION_Y_DEFAULT   , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_FRICTION_Y           , PLAYER_FRICTION_DEFAULT
SetFieldB ENT_WIDTH                , SPRITE_BIRD_WIDTH
SetFieldB ENT_HEIGHT               , SPRITE_BIRD_HEIGHT
SetFieldW ENT_SPRITE               , #_sprite_bird_0
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_boomerang_ia_0
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , 3
_AUX_INFLICTS = 0
_AUX_INFLICTS = _AUX_INFLICTS | ENTITY_TYPE_FLAG_PLAYER
_AUX_INFLICTS = _AUX_INFLICTS | ENTITY_TYPE_FLAG_PLAYER_SHOT
SetFieldB ENT_INFLICTS_DAMAGE_ON   , _AUX_INFLICTS
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_bird_standing_right
SetFieldW ENT_LAST_SPRITE          , #_sprite_bird_0
SetFieldW ENT_ANIMATION_ARRAY      , #_bird_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 5
SetFieldW ENT_DEATH_ANIMATION      , #_animation_bird_death
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , POINTS_BIRD_BULLET
DefineEntity birdShot


factory_createBoldMinion::
	ld hl, #bold_minion
	call man_entity_createEntity
	ret

;;Next map entity triger
SetFieldB ENT_TYPE_FLAG             , ENTITY_TYPE_FLAG_NEXT_MAP
SetFieldB ENT_TYPE_ID               , ENTITY_TYPE_ID_NEXT_MAP
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
SetFieldB ENT_COMPONENTS_H         , 0
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , 1
SetFieldB ENT_HEIGHT               , 24
SetFieldW ENT_SPRITE               , #0x0000
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_NULL
SetFieldW ENT_CURRENT_ANIMATION    , #0x0000
SetFieldW ENT_LAST_SPRITE          , #0x0000
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #0x0000
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity next_map


;;Indicator
SetFieldB ENT_TYPE_FLAG             , ENTITY_TYPE_FLAG_NEXT_MAP
SetFieldB ENT_TYPE_ID               , ENTITY_TYPE_ID_NEXT_MAP_DOOR
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
SetFieldB ENT_COMPONENTS_H         , 0
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , INDICATOR_WIDTH
SetFieldB ENT_HEIGHT               , INDICATOR_HEIGHT
SetFieldW ENT_SPRITE               , _indicator_0
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_NULL
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_indicator
SetFieldW ENT_LAST_SPRITE          , #0x0000
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #0x0000
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity door_indicator



;;Indicator
SetFieldB ENT_TYPE_FLAG             , ENTITY_TYPE_FLAG_NEXT_MAP
SetFieldB ENT_TYPE_ID               , ENTITY_TYPE_ID_NEXT_MAP_ELEVATOR
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_RENDER
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_ANIMATION
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
SetFieldB ENT_COMPONENTS_H         , 0
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , INDICATOR_WIDTH
SetFieldB ENT_HEIGHT               , INDICATOR_HEIGHT
SetFieldW ENT_SPRITE               , _indicator_0
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_NULL
SetFieldW ENT_CURRENT_ANIMATION    , #_animation_indicator
SetFieldW ENT_LAST_SPRITE          , #0x0000
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #0x0000
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity elevator_indicator


;;Next map entity triger horizontal
SetFieldB ENT_TYPE_FLAG             , ENTITY_TYPE_FLAG_NEXT_MAP
SetFieldB ENT_TYPE_ID               , ENTITY_TYPE_ID_NEXT_MAP
_COMPONENTS_AUX = 0
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_COLLISION
_COMPONENTS_AUX = _COMPONENTS_AUX |	COMPONENT_L_HEALTH
SetFieldB ENT_COMPONENTS_L         , _COMPONENTS_AUX
SetFieldB ENT_COMPONENTS_H         , 0
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , 24
SetFieldB ENT_HEIGHT               , 1
SetFieldW ENT_SPRITE               , #0x0000
SetFieldB ENT_COLLIDES_WITH        , ENTITY_TYPE_FLAG_PLAYER
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 1
SetFieldB ENT_HEALTH               , 1
SetFieldB ENT_ATTACK               , 3
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_NULL
SetFieldW ENT_CURRENT_ANIMATION    , #0x0000
SetFieldW ENT_LAST_SPRITE          , #0x0000
SetFieldW ENT_ANIMATION_ARRAY      , #_no_animation_array
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #0x0000
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity next_mapH


;;Dummy entity
SetFieldB ENT_TYPE_FLAG            , ENTITY_TYPE_FLAG_NULL
SetFieldB ENT_TYPE_ID              , 0xFF
SetFieldB ENT_COMPONENTS_L         , 0
SetFieldB ENT_COMPONENTS_H         , 0
SetFieldW ENT_Y_WORLD              , 0
SetFieldW ENT_X_WORLD              , 0
SetFieldB ENT_Y                    , 0
SetFieldB ENT_X                    , 0
SetFieldB ENT_VEL_Y                , 0
SetFieldB ENT_VEL_X                , 0
SetFieldB ENT_ACCELERATION_X       , 0
SetFieldB ENT_ACCELERATION_Y       , 0
SetFieldB ENT_FRICTION_X_DEFAULT   , 0
SetFieldB ENT_FRICTION_X           , 0
SetFieldB ENT_FRICTION_Y_DEFAULT   , 0
SetFieldB ENT_FRICTION_Y           , 0
SetFieldB ENT_WIDTH                , 0
SetFieldB ENT_HEIGHT               , 0
SetFieldW ENT_SPRITE               , #0x0000
SetFieldB ENT_COLLIDES_WITH        , 0
SetFieldW ENT_IA_STATE             , #_no_state
SetFieldB ENT_MAX_HEALTH           , 0
SetFieldB ENT_HEALTH               , 0
SetFieldB ENT_ATTACK               , 0
SetFieldB ENT_INFLICTS_DAMAGE_ON   , ENTITY_TYPE_FLAG_NULL
SetFieldW ENT_CURRENT_ANIMATION    , #0x0000
SetFieldW ENT_LAST_SPRITE          , #0x0000
SetFieldW ENT_ANIMATION_ARRAY      , #0x0000
SetFieldB ENT_INVINCIBLE_TIME      , 0
SetFieldB ENT_DEATH_COUNTER        , 0
SetFieldW ENT_DEATH_ANIMATION      , #0x0000
SetFieldB ENT_FACING_DIR           , 0
SetFieldW ENT_POINTS               , 0
DefineEntity dummyEntity

factory_createPlayer::
	ld hl, #player
	call man_entity_createEntity
	ld a, #MAX_ENERGY
	ld (man_game_playerEnergy), a
	ret

factory_createBoss1::
	ld hl, #boss1
	call man_entity_createEntity
	ret

factory_createBoss2::
	ld hl, #boss2
	call man_entity_createEntity
	ret


factory_createPlayerShot::
	ld hl, #playerShot
	call man_entity_createEntity
	ret

factory_createBossShot::
	ld hl, #bossShot
	call man_entity_createEntity
	ret

factory_createBossShotgunShot::
ld hl, #bossShotgunShot
call man_entity_createEntity
ret

factory_createBirdShot::
    ld hl, #birdShot
    call man_entity_createEntity
    ret

factory_createStaticBirdShot::
    ld hl, #staticBirdShot
    call man_entity_createEntity
    ret

